Index: issm/trunk/src/c/toolkits/mumps/MumpsSolve.cpp
===================================================================
--- issm/trunk/src/c/toolkits/mumps/MumpsSolve.cpp	(revision 25994)
+++ issm/trunk/src/c/toolkits/mumps/MumpsSolve.cpp	(revision 26744)
@@ -485,19 +485,19 @@
 
 #ifdef _HAVE_CODIPACK_
-void MumpsSolve_codi_b(void* tape_in,void* data_in,void* ra) {/*{{{*/
+#if _CODIPACK_MAJOR_==2
+using Tape = typename IssmDouble::Tape;
+using AccessInterface = codi::VectorAccessInterface<typename Tape::Real, typename Tape::Identifier>;
+void MumpsSolve_codi_b(Tape* tape, void* data_in, AccessInterface* ra) {/*{{{*/
 
 	/*recast data_in and tape*/
-  codi::DataStore* data = (codi::DataStore*)data_in;
-  //IssmDouble::TapeType& tape = (IssmDouble::TapeType&)tape_in;
-  IssmDouble::TapeType& tape = IssmDouble::getGlobalTape();
-
+  codi::ExternalFunctionUserData* data = (codi::ExternalFunctionUserData*)data_in;
 
   IssmDouble::Real* valueATrans;
-  IssmDouble::GradientData* indexATrans;
+  IssmDouble::Identifier* indexATrans;
   int* irnATrans;
   int* jcnATrans;
-  IssmDouble::GradientData* indexB;
+  IssmDouble::Identifier* indexB;
   IssmDouble::Real* valueX;
-  IssmDouble::GradientData* indexX;
+  IssmDouble::Identifier* indexX;
   int n;
   int nnz;
@@ -518,11 +518,11 @@
 
   // create the adjoint vector for x and reset the adjoint values on the tape
-  IssmDouble::GradientValue* adjX = xNew<IssmDouble::GradientValue>(n);
-  getVectorAdjoint(tape, indexX, adjX, n);
+  IssmDouble::Gradient* adjX = xNew<IssmDouble::Gradient>(n);
+  getVectorAdjoint(*tape, indexX, adjX, n);
 
   MumpsSolve(n, nnz, local_nnz, irnATrans, jcnATrans, valueATrans, adjX, parameters);
   // adjX contains now the solution
 
-  updateVectorAdjoint(tape, indexB, adjX, n);
+  updateVectorAdjoint(*tape, indexB, adjX, n);
 
   // bcast dp_y (the solution of the forward system)
@@ -534,5 +534,5 @@
     // we access the transposed matrix here because we stored the indices in a transposed way
     // -1 is substracted because jcn and irn are stored with fortran indexing
-    updateAdjoint(tape, indexATrans[i], -adjX[jcnATrans[i]-1]*valueX[irnATrans[i]-1]);
+    updateAdjoint(*tape, indexATrans[i], -adjX[jcnATrans[i]-1]*valueX[irnATrans[i]-1]);
   }
 
@@ -540,16 +540,16 @@
 }
 /*}}}*/
-void MumpsSolve_codi_delete(void* tape_in,void* data_in) {/*{{{*/
+void MumpsSolve_codi_delete(Tape* tape,void* data_in) {/*{{{*/
 
 	/*recast data_in*/
-	codi::DataStore* data = (codi::DataStore*)data_in;
+	codi::ExternalFunctionUserData* data = (codi::ExternalFunctionUserData*)data_in;
 
   IssmDouble::Real* valueATrans;
-  IssmDouble::GradientData* indexATrans;
+  IssmDouble::Identifier* indexATrans;
   int* irnATrans;
   int* jcnATrans;
-  IssmDouble::GradientData* indexB;
+  IssmDouble::Identifier* indexB;
   IssmDouble::Real* valueX;
-  IssmDouble::GradientData* indexX;
+  IssmDouble::Identifier* indexX;
   int n;
   int nnz;
@@ -581,13 +581,13 @@
 /*}}}*/
 void MumpsSolve(int n,int nnz,int local_nnz,int* irn_loc,int* jcn_loc,IssmDouble *a_loc,IssmDouble *rhs,Parameters* parameters){/*{{{*/
-  IssmDouble::TapeType& tape = IssmDouble::getGlobalTape();
-  codi::DataStore* dataHandler = NULL;
+  IssmDouble::Tape& tape = IssmDouble::getTape();
+  codi::ExternalFunctionUserData* dataHandler = NULL;
 
   if(tape.isActive()) {
-    dataHandler = new codi::DataStore();
+    dataHandler = new codi::ExternalFunctionUserData();
 
     // create the index and double vector for the matrix
     IssmDouble::Real* valueATrans = xNew<IssmDouble::Real>(local_nnz);
-    IssmDouble::GradientData* indexATrans = xNew<IssmDouble::GradientData>(local_nnz);
+    IssmDouble::Identifier* indexATrans = xNew<IssmDouble::Identifier>(local_nnz);
     int* irnATrans = xNew<int>(local_nnz);
     int* jcnATrans = xNew<int>(local_nnz);
@@ -601,5 +601,5 @@
 
     // create the index vector for a (primal values are not needed for a)
-    IssmDouble::GradientData* indexB = xNew<IssmDouble::GradientData>(n);
+    IssmDouble::Identifier* indexB = xNew<IssmDouble::Identifier>(n);
     getVectorGradData(rhs, indexB, n);
 
@@ -626,5 +626,5 @@
   if(tape.isActive()) {
     // create the index vector X and register x as active variables
-    IssmDouble::GradientData* indexX = xNew<IssmDouble::GradientData>(n);
+    IssmDouble::Identifier* indexX = xNew<IssmDouble::Identifier>(n);
     registerVector(rhs, indexX, n);
 
@@ -638,6 +638,5 @@
     dataHandler->addData(parameters); // we assume here that parameters is still intact when the reverse run is called
 
-	 //tape.pushExternalFunction(&MumpsSolve_codi_b, dataHandler, &MumpsSolve_codi_delete);
-    tape.pushExternalFunctionHandle(&MumpsSolve_codi_b,(void*)dataHandler, &MumpsSolve_codi_delete);
+	 tape.pushExternalFunction(codi::ExternalFunction<Tape>::create(&MumpsSolve_codi_b,(void*)dataHandler, &MumpsSolve_codi_delete));
   }
   else{
@@ -649,3 +648,171 @@
 }
 /*}}}*/
-#endif
+#elif _CODIPACK_MAJOR_==1
+void MumpsSolve_codi_b(void* tape_in,void* data_in,void* ra) {/*{{{*/
+
+	/*recast data_in and tape*/
+	codi::DataStore* data = (codi::DataStore*)data_in;
+	//IssmDouble::TapeType& tape = (IssmDouble::TapeType&)tape_in;
+	IssmDouble::TapeType& tape = IssmDouble::getGlobalTape();
+
+
+	IssmDouble::Real* valueATrans;
+	IssmDouble::GradientData* indexATrans;
+	int* irnATrans;
+	int* jcnATrans;
+	IssmDouble::GradientData* indexB;
+	IssmDouble::Real* valueX;
+	IssmDouble::GradientData* indexX;
+	int n;
+	int nnz;
+	int local_nnz;
+	Parameters* parameters;
+
+	data->getData(valueATrans);
+	data->getData(indexATrans);
+	data->getData(irnATrans);
+	data->getData(jcnATrans);
+	data->getData(indexB);
+	data->getData(valueX);
+	data->getData(indexX);
+	data->getData(n);
+	data->getData(nnz);
+	data->getData(local_nnz);
+	data->getData(parameters);
+
+	// create the adjoint vector for x and reset the adjoint values on the tape
+	IssmDouble::GradientValue* adjX = xNew<IssmDouble::GradientValue>(n);
+	getVectorAdjoint(tape, indexX, adjX, n);
+
+	MumpsSolve(n, nnz, local_nnz, irnATrans, jcnATrans, valueATrans, adjX, parameters);
+	// adjX contains now the solution
+
+	updateVectorAdjoint(tape, indexB, adjX, n);
+
+	// bcast dp_y (the solution of the forward system)
+	ISSM_MPI_Bcast(valueX,n,ISSM_MPI_PDOUBLE,0,IssmComm::GetComm());
+	// bcast the adjoint of the right-hand-side, i.e. this solution
+	ISSM_MPI_Bcast(adjX,n,ISSM_MPI_PDOUBLE,0,IssmComm::GetComm());
+
+	for(int i=0; i<local_nnz; ++i) {
+		// we access the transposed matrix here because we stored the indices in a transposed way
+		// -1 is substracted because jcn and irn are stored with fortran indexing
+		updateAdjoint(tape, indexATrans[i], -adjX[jcnATrans[i]-1]*valueX[irnATrans[i]-1]);
+	}
+
+	xDelete(adjX);
+}
+/*}}}*/
+void MumpsSolve_codi_delete(void* tape_in,void* data_in) {/*{{{*/
+
+	/*recast data_in*/
+	codi::DataStore* data = (codi::DataStore*)data_in;
+
+	IssmDouble::Real* valueATrans;
+	IssmDouble::GradientData* indexATrans;
+	int* irnATrans;
+	int* jcnATrans;
+	IssmDouble::GradientData* indexB;
+	IssmDouble::Real* valueX;
+	IssmDouble::GradientData* indexX;
+	int n;
+	int nnz;
+	int local_nnz;
+	Parameters* parameters;
+
+	data->getData(valueATrans);
+	data->getData(indexATrans);
+	data->getData(irnATrans);
+	data->getData(jcnATrans);
+	data->getData(indexB);
+	data->getData(valueX);
+	data->getData(indexX);
+	data->getData(n);
+	data->getData(nnz);
+	data->getData(local_nnz);
+	data->getData(parameters);
+
+	xDelete(valueATrans);
+	xDelete(indexATrans);
+	xDelete(irnATrans);
+	xDelete(jcnATrans);
+	xDelete(indexB);
+	xDelete(valueX);
+	xDelete(indexX);
+
+	delete data;
+}
+/*}}}*/
+void MumpsSolve(int n,int nnz,int local_nnz,int* irn_loc,int* jcn_loc,IssmDouble *a_loc,IssmDouble *rhs,Parameters* parameters){/*{{{*/
+	IssmDouble::TapeType& tape = IssmDouble::getGlobalTape();
+	codi::DataStore* dataHandler = NULL;
+
+	if(tape.isActive()) {
+		dataHandler = new codi::DataStore();
+
+		// create the index and double vector for the matrix
+		IssmDouble::Real* valueATrans = xNew<IssmDouble::Real>(local_nnz);
+		IssmDouble::GradientData* indexATrans = xNew<IssmDouble::GradientData>(local_nnz);
+		int* irnATrans = xNew<int>(local_nnz);
+		int* jcnATrans = xNew<int>(local_nnz);
+
+		// read the data for the matrix A in a transposed fashion
+		for (int i=0; i<local_nnz; ++i) {
+			getPrimalAndGradData(a_loc[i], valueATrans[i], indexATrans[i]);
+			irnATrans[i]=jcn_loc[i];  // transposed store
+			jcnATrans[i]=irn_loc[i];  // transposed store
+		}
+
+		// create the index vector for a (primal values are not needed for a)
+		IssmDouble::GradientData* indexB = xNew<IssmDouble::GradientData>(n);
+		getVectorGradData(rhs, indexB, n);
+
+		dataHandler->addData(valueATrans);
+		dataHandler->addData(indexATrans);
+		dataHandler->addData(irnATrans);
+		dataHandler->addData(jcnATrans);
+		dataHandler->addData(indexB);
+	}
+
+	// unpack the primal values from the matrix and the vector
+	IssmDouble::Real* valueA = xNew<IssmDouble::Real>(local_nnz);
+	IssmDouble::Real* valueB = xNew<IssmDouble::Real>(n);
+	// read the data from A and B
+	getVectorPrimal(a_loc, valueA, local_nnz);
+	getVectorPrimal(rhs, valueB, n);
+
+	MumpsSolve(n, nnz, local_nnz, irn_loc, jcn_loc, valueA, valueB, parameters);
+	// valueB contains now the solution
+
+	// pack the values into rhs
+	setVectorPrimal(rhs, valueB, n);
+
+	if(tape.isActive()) {
+		// create the index vector X and register x as active variables
+		IssmDouble::GradientData* indexX = xNew<IssmDouble::GradientData>(n);
+		registerVector(rhs, indexX, n);
+
+		dataHandler->addData(valueB); // contains the values from x
+		dataHandler->addData(indexX);
+
+		// store other arguments
+		dataHandler->addData(n);
+		dataHandler->addData(nnz);
+		dataHandler->addData(local_nnz);
+		dataHandler->addData(parameters); // we assume here that parameters is still intact when the reverse run is called
+
+		//tape.pushExternalFunction(&MumpsSolve_codi_b, dataHandler, &MumpsSolve_codi_delete);
+		tape.pushExternalFunctionHandle(&MumpsSolve_codi_b,(void*)dataHandler, &MumpsSolve_codi_delete);
+	}
+	else{
+		// if the tape is active valueB is stored in the dataHandler and deleted in the reverse sweep
+		xDelete(valueB);
+	}
+
+	xDelete(valueA);
+}
+/*}}}*/
+#else
+#error "_CODIPACK_MAJOR_ not supported"
+#endif
+#endif
Index: issm/trunk/src/c/toolkits/objects/Matrix.h
===================================================================
--- issm/trunk/src/c/toolkits/objects/Matrix.h	(revision 25994)
+++ issm/trunk/src/c/toolkits/objects/Matrix.h	(revision 26744)
@@ -266,5 +266,5 @@
 		}
 		/*}}}*/
-		doubletype* ToSerial(void){/*{{{*/
+		doubletype* ToMPISerial0(void){/*{{{*/
 
 			doubletype* output=NULL;
@@ -272,9 +272,9 @@
 			if(type==PetscMatType){
 				#ifdef _HAVE_PETSC_
-				output=this->pmatrix->ToSerial();
-				#endif
-			}
-			else{
-				output=this->imatrix->ToSerial();
+				output=this->pmatrix->ToMPISerial0();
+				#endif
+			}
+			else{
+				output=this->imatrix->ToMPISerial0();
 			}
 
@@ -282,4 +282,20 @@
 		}
 		/*}}}*/
+		doubletype* ToMPISerial(void){/*{{{*/
+
+			doubletype* output=NULL;
+
+			if(type==PetscMatType){
+				#ifdef _HAVE_PETSC_
+				output=this->pmatrix->ToMPISerial();
+				#endif
+			}
+			else{
+				_error_("not implemented yet!");
+			}
+
+			return output;
+		}
+		/*}}}*/
 		void SetValues(int m,int* idxm,int n,int* idxn,IssmDouble* values,InsMode mode){/*{{{*/
 
@@ -307,8 +323,6 @@
 		}
 		/*}}}*/
-		/*
-		* sets all values to 0 but keeps the structure of a sparse matrix
-		*/
 		void SetZero(void) {/*{{{*/
+			// sets all values to 0 but keeps the structure of a sparse matrix
 			if(type==PetscMatType){
 				#ifdef _HAVE_PETSC_
Index: issm/trunk/src/c/toolkits/objects/Vector.h
===================================================================
--- issm/trunk/src/c/toolkits/objects/Vector.h	(revision 25994)
+++ issm/trunk/src/c/toolkits/objects/Vector.h	(revision 26744)
@@ -406,4 +406,15 @@
 		}
 		/*}}}*/
-};
+void Sum(doubletype* pvalue){ /*{{{*/
+	_assert_(this);/*{{{*/
+
+	if(type==PetscVecType){
+		#ifdef _HAVE_PETSC_
+		this->pvector->Sum(pvalue);
+		#endif
+	}
+	else this->ivector->Sum(pvalue);
+}
+/*}}}*/
+}; /*}}}*/
 #endif //#ifndef _VECTOR_H_
Index: issm/trunk/src/c/toolkits/petsc/objects/PetscMat.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/objects/PetscMat.cpp	(revision 25994)
+++ issm/trunk/src/c/toolkits/petsc/objects/PetscMat.cpp	(revision 26744)
@@ -171,9 +171,16 @@
 }
 /*}}}*/
-IssmDouble* PetscMat::ToSerial(void){/*{{{*/
+IssmDouble* PetscMat::ToMPISerial(void){/*{{{*/
 
 	 IssmDouble* output=NULL;
-
-	 MatToSerial(&output,this->matrix,IssmComm::GetComm());
+	 MatToMPISerial(&output,this->matrix,IssmComm::GetComm(),true);
+	 return output;
+
+}
+/*}}}*/
+IssmDouble* PetscMat::ToMPISerial0(void){/*{{{*/
+
+	 IssmDouble* output=NULL;
+	 MatToMPISerial(&output,this->matrix,IssmComm::GetComm(),false);
 	 return output;
 
Index: issm/trunk/src/c/toolkits/petsc/objects/PetscMat.h
===================================================================
--- issm/trunk/src/c/toolkits/petsc/objects/PetscMat.h	(revision 25994)
+++ issm/trunk/src/c/toolkits/petsc/objects/PetscMat.h	(revision 26744)
@@ -49,5 +49,6 @@
 		void MatMult(PetscVec* X,PetscVec* AX);
 		PetscMat* Duplicate(void);
-		IssmDouble* ToSerial(void);
+		IssmDouble* ToMPISerial(void);
+		IssmDouble* ToMPISerial0(void);
 		void SetValues(int m,int* idxm,int n,int* idxn,IssmDouble* values,InsMode mode);
 		void Convert(MatrixType type);
Index: issm/trunk/src/c/toolkits/petsc/objects/PetscVec.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/objects/PetscVec.cpp	(revision 25994)
+++ issm/trunk/src/c/toolkits/petsc/objects/PetscVec.cpp	(revision 26744)
@@ -37,4 +37,5 @@
 	VecSetSizes(this->vector,m,M);
 	VecSetFromOptions(this->vector);
+	VecSetOption(this->vector,VEC_IGNORE_NEGATIVE_INDICES,PETSC_TRUE);
 	VecSet(this->vector,0.0);
 
@@ -249,4 +250,11 @@
 }
 /*}}}*/
+void PetscVec::Sum(IssmDouble* pvalue){/*{{{*/
+
+	_assert_(this->vector);
+	VecSum(this->vector,pvalue);
+
+}
+/*}}}*/
 IssmDouble PetscVec::Dot(PetscVec* input){/*{{{*/
 
Index: issm/trunk/src/c/toolkits/petsc/objects/PetscVec.h
===================================================================
--- issm/trunk/src/c/toolkits/petsc/objects/PetscVec.h	(revision 25994)
+++ issm/trunk/src/c/toolkits/petsc/objects/PetscVec.h	(revision 26744)
@@ -58,4 +58,5 @@
 		void        Scale(IssmDouble scale_factor);
 		void        Pow(IssmDouble scale_factor);
+		void        Sum(IssmDouble* pvalue);
 		void        PointwiseDivide(PetscVec* x,PetscVec* y);
 		void        PointwiseMult(PetscVec* x,PetscVec* y);
Index: issm/trunk/src/c/toolkits/petsc/patches/MatToMPISerial.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/MatToMPISerial.cpp	(revision 26744)
+++ issm/trunk/src/c/toolkits/petsc/patches/MatToMPISerial.cpp	(revision 26744)
@@ -0,0 +1,96 @@
+/*!\file MatToMPISerial.cpp
+ * \brief gather a Petsc Mat matrix onto all cpus
+ */
+
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include "../petscincludes.h"
+#include "../../../shared/shared.h"
+
+void MatToMPISerial(double** poutmatrix,Mat matrix,ISSM_MPI_Comm comm,bool broadcast){
+
+	int i;
+	int my_rank;
+	int num_procs;
+
+	/*Petsc variables*/
+	PetscInt lower_row,upper_row; 
+	int range;
+	int M,N; //size of matrix
+	ISSM_MPI_Status status;
+	int* idxm=NULL;
+	int* idxn=NULL; 
+	double* local_matrix=NULL; /*matrix local to each node used for temporary holding matrix values*/
+	int buffer[3];
+
+	/*recover my_rank and num_procs:*/
+	ISSM_MPI_Comm_size(comm,&num_procs);
+	ISSM_MPI_Comm_rank(comm,&my_rank);
+
+	/*Output*/
+	double* outmatrix=NULL;
+
+	/*get matrix size: */
+	MatGetSize(matrix,&M,&N);
+
+	/*partition: */
+	MatGetOwnershipRange(matrix,&lower_row,&upper_row);    
+	upper_row--; 
+	range=upper_row-lower_row+1;
+
+	/*Local and global allocation*/
+	if(broadcast || my_rank==0){ 
+		outmatrix=xNew<double>(M*N);
+	}
+
+	if (range){
+		local_matrix=xNew<double>(N*range);
+		idxm=xNew<int>(range);  
+		idxn=xNew<int>(N);  
+
+		for (i=0;i<N;i++){
+			*(idxn+i)=i;
+		}
+		for (i=0;i<range;i++){
+			*(idxm+i)=lower_row+i;
+		}
+
+		MatGetValues(matrix,range,idxm,N,idxn,local_matrix);     
+	}
+
+	/*Now each node holds its local_matrix containing range rows. 
+	 * We send these rows to the matrix on node 0*/
+
+	for (i=1;i<num_procs;i++){
+		if (my_rank==i){ 
+			buffer[0]=my_rank;
+			buffer[1]=lower_row;
+			buffer[2]=range;
+			ISSM_MPI_Send(buffer,3,ISSM_MPI_INT,0,1,comm);   
+			if (range)ISSM_MPI_Send(local_matrix,N*range,ISSM_MPI_PDOUBLE,0,1,comm); 
+		}
+		if (my_rank==0){
+			ISSM_MPI_Recv(buffer,3,ISSM_MPI_INT,i,1,comm,&status); 
+			if (buffer[2])ISSM_MPI_Recv(outmatrix+(buffer[1]*N),N*buffer[2],ISSM_MPI_PDOUBLE,i,1,comm,&status);
+		}
+	} 
+	if (my_rank==0){ 
+		//Still have the local_matrix on node 0 to take care of.
+		if (range) memcpy(outmatrix,local_matrix,N*range*sizeof(double));
+	} 
+
+	if(broadcast){
+		/*Broadcast:*/
+		ISSM_MPI_Bcast(outmatrix,M*N,ISSM_MPI_PDOUBLE,0,comm);
+	}
+
+	/*Assign output pointer: */
+	xDelete<int>(idxm);
+	xDelete<int>(idxn);
+	xDelete<double>(local_matrix);
+	*poutmatrix=outmatrix;
+}
Index: issm/trunk/src/c/toolkits/petsc/patches/NewMat.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/NewMat.cpp	(revision 25994)
+++ issm/trunk/src/c/toolkits/petsc/patches/NewMat.cpp	(revision 26744)
@@ -111,4 +111,5 @@
 	MatSetSizes(outmatrix,m,n,M,N);
 	MatSetFromOptions(outmatrix);
+	MatSetOption(outmatrix,MAT_IGNORE_ZERO_ENTRIES,PETSC_TRUE);
 
 	/*preallocation  according to type: */
Index: issm/trunk/src/c/toolkits/petsc/patches/NewVec.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/NewVec.cpp	(revision 25994)
+++ issm/trunk/src/c/toolkits/petsc/patches/NewVec.cpp	(revision 26744)
@@ -35,4 +35,5 @@
 	VecSetSizes(vector,local_size,PETSC_DECIDE); 
 	VecSetFromOptions(vector); 
+	VecSetOption(vector,VEC_IGNORE_NEGATIVE_INDICES,PETSC_TRUE);
 
 	return vector;
Index: issm/trunk/src/c/toolkits/petsc/patches/petscpatches.h
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/petscpatches.h	(revision 25994)
+++ issm/trunk/src/c/toolkits/petsc/patches/petscpatches.h	(revision 26744)
@@ -27,9 +27,8 @@
 void VecFree(Vec* pvec);
 void KSPFree(KSP* pksp);
-int MatPartition(Mat* poutmatrix,Mat matrixA,double* row_partition_vector,int row_partition_vector_size ,
-		double* col_partition_vector,int col_partition_vector_size);
+int MatPartition(Mat* poutmatrix,Mat matrixA,double* row_partition_vector,int row_partition_vector_size, double* col_partition_vector,int col_partition_vector_size);
 void PetscOptionsDetermineSolverType(int* psolver_type);
 void MatMultPatch(Mat A,Vec X, Vec AX,ISSM_MPI_Comm comm);
-void MatToSerial(double** poutmatrix,Mat matrix,ISSM_MPI_Comm comm);
+void MatToMPISerial(double** poutmatrix,Mat matrix,ISSM_MPI_Comm comm,bool broadcast=true);
 Vec  SerialToVec(double* vector,int vector_size);
 InsertMode ISSMToPetscInsertMode(InsMode mode);
Index: issm/trunk/src/jl/core/analyses/analysis.jl
===================================================================
--- issm/trunk/src/jl/core/analyses/analysis.jl	(revision 26744)
+++ issm/trunk/src/jl/core/analyses/analysis.jl	(revision 26744)
@@ -0,0 +1,2 @@
+#Analysis class definitions
+abstract type Analysis end
Index: issm/trunk/src/jl/core/analyses/masstransportanalysis.jl
===================================================================
--- issm/trunk/src/jl/core/analyses/masstransportanalysis.jl	(revision 26744)
+++ issm/trunk/src/jl/core/analyses/masstransportanalysis.jl	(revision 26744)
@@ -0,0 +1,275 @@
+#MasstransportAnalysis class definition
+struct MasstransportAnalysis <: Analysis#{{{
+end #}}}
+
+#Model Processing
+function CreateConstraints(analysis::MasstransportAnalysis,constraints::Vector{Constraint},md::model) #{{{
+
+	#load constraints from model
+	spcthickness = md.masstransport.spcthickness
+
+	count = 1
+	for i in 1:md.mesh.numberofvertices
+		if ~isnan(spcthickness[i])
+			push!(constraints,Constraint(count,i,1,spcthickness[i]))
+			count+=1
+		end
+	end
+
+end#}}}
+function CreateNodes(analysis::MasstransportAnalysis,nodes::Vector{Node},md::model) #{{{
+
+	numdof = 1
+	for i in 1:md.mesh.numberofvertices
+		push!(nodes,Node(i,i,true,true,numdof,-ones(Int64,numdof), ones(Int64,numdof), -ones(Int64,numdof), zeros(numdof)))
+	end
+end#}}}
+function UpdateElements(analysis::MasstransportAnalysis,elements::Vector{Tria}, inputs::Inputs, md::model) #{{{
+
+	#Provide node indices to element
+	for i in 1:md.mesh.numberofelements
+		Update(elements[i],inputs,i,md,P1Enum)
+	end
+
+	#Add necessary inputs to perform this analysis
+	FetchDataToInput(md,inputs,elements,md.geometry.thickness,ThicknessEnum)
+	FetchDataToInput(md,inputs,elements,md.geometry.surface,SurfaceEnum)
+	FetchDataToInput(md,inputs,elements,md.geometry.base,BaseEnum)
+	FetchDataToInput(md,inputs,elements,md.geometry.bed,BedEnum)
+	FetchDataToInput(md,inputs,elements,md.basalforcings.groundedice_melting_rate./md.constants.yts,BasalforcingsGroundediceMeltingRateEnum)
+	FetchDataToInput(md,inputs,elements,md.basalforcings.floatingice_melting_rate./md.constants.yts,BasalforcingsFloatingiceMeltingRateEnum)
+	FetchDataToInput(md,inputs,elements,md.smb.mass_balance./md.constants.yts,SmbMassBalanceEnum)
+	FetchDataToInput(md,inputs,elements,md.mask.ice_levelset, MaskIceLevelsetEnum)
+	FetchDataToInput(md,inputs,elements,md.mask.ocean_levelset, MaskOceanLevelsetEnum)
+	FetchDataToInput(md,inputs,elements,md.initialization.vx./md.constants.yts,VxEnum)
+	FetchDataToInput(md,inputs,elements,md.initialization.vy./md.constants.yts,VyEnum)
+
+end#}}}
+function UpdateParameters(analysis::MasstransportAnalysis,parameters::Parameters,md::model) #{{{
+
+	AddParam(parameters, md.masstransport.min_thickness, MasstransportMinThicknessEnum)
+	AddParam(parameters, md.masstransport.stabilization, MasstransportStabilizationEnum)
+
+end#}}}
+
+#Finite Element Analysis
+function Core(analysis::MasstransportAnalysis,femmodel::FemModel)# {{{
+
+	println("   computing mass transport")
+	SetCurrentConfiguration!(femmodel, analysis)
+
+	InputDuplicatex(femmodel, ThicknessEnum, ThicknessOldEnum)
+	InputDuplicatex(femmodel, BaseEnum, BaseOldEnum)
+	InputDuplicatex(femmodel, SurfaceEnum, SurfaceOldEnum)
+
+	solutionsequence_linear(femmodel,analysis)
+
+	#Save output
+	RequestedOutputsx(femmodel, [ThicknessEnum, SurfaceEnum, BaseEnum])
+
+end #}}}
+function CreateKMatrix(analysis::MasstransportAnalysis,element::Tria)# {{{
+
+	#Return if there is no ice in this element
+	if(!IsIceInElement(element)) return end
+
+	#Internmediaries
+	numnodes = 3
+	
+	#Initialize Element matrix and basis function derivatives
+	Ke = ElementMatrix(element.nodes)
+	dbasis = Matrix{Float64}(undef,numnodes,2)
+	basis  = Vector{Float64}(undef,numnodes)
+
+	#Retrieve all inputs and parameters
+	xyz_list = GetVerticesCoordinates(element.vertices)
+	vx_input      = GetInput(element, VxEnum)
+	vy_input      = GetInput(element, VyEnum)
+	dt            = FindParam(element, TimesteppingTimeStepEnum)
+	stabilization = FindParam(element, MasstransportStabilizationEnum)
+
+	h = CharacteristicLength(element)
+
+	#Start integrating
+	gauss = GaussTria(2)
+	for ig in 1:gauss.numgauss
+
+		Jdet = JacobianDeterminant(xyz_list, gauss)
+		NodalFunctionsDerivatives(element, dbasis, xyz_list, gauss)
+		NodalFunctions(element, basis, gauss, ig, P1Enum)
+
+      #Transient term
+		for i in 1:numnodes
+			for j in 1:numnodes
+				Ke.values[i ,j] += gauss.weights[ig]*Jdet*basis[i]*basis[j]
+			end
+		end
+
+      #Advection term
+		vx  = GetInputValue(vx_input, gauss, ig)
+      vy  = GetInputValue(vy_input, gauss, ig)
+		dvx = GetInputDerivativeValue(vx_input, xyz_list, gauss, ig)
+      dvy = GetInputDerivativeValue(vy_input, xyz_list, gauss, ig)
+      for i in 1:numnodes
+         for j in 1:numnodes
+            #\phi_i \phi_j \nabla\cdot v
+            Ke.values[i ,j] += dt*gauss.weights[ig]*Jdet*basis[i]*basis[j]*(dvx[1] + dvy[2])
+            #\phi_i v\cdot\nabla\phi_j
+            Ke.values[i ,j] += dt*gauss.weights[ig]*Jdet*basis[i]*(vx*dbasis[j,1] + vy*dbasis[j,2])
+         end
+      end
+
+		#Stabilization
+		if(stabilization==0)
+			#do nothing
+		elseif (stabilization==1)
+			vx = GetInputAverageValue(vx_input)
+			vy = GetInputAverageValue(vy_input)
+			D  = dt*gauss.weights[ig]*Jdet*[h/2*abs(vx) 0; 0 h/2*abs(vy)]
+			for i in 1:numnodes; for j in 1:numnodes
+					Ke.values[i ,j] += (dbasis[i,1]*(D[1,1]*dbasis[j,1] + D[1,2]*dbasis[j,2]) +
+											  dbasis[i,2]*(D[2,1]*dbasis[j,1] + D[2,2]*dbasis[j,2]))
+			end end
+		else
+			error("Stabilization ",stabilization, " not supported yet")
+		end
+	end
+
+	return Ke
+end #}}}
+function CreatePVector(analysis::MasstransportAnalysis,element::Tria)# {{{
+
+	#Return if there is no ice in this element
+	if(!IsIceInElement(element)) return end
+
+	#Internmediaries
+	numnodes = 3
+
+	#Initialize Element vectro and basis functions
+	pe = ElementVector(element.nodes)
+	basis = Vector{Float64}(undef,numnodes)
+
+	#Retrieve all inputs and parameters
+	xyz_list = GetVerticesCoordinates(element.vertices)
+	H_input         = GetInput(element, ThicknessEnum)
+	gmb_input       = GetInput(element, BasalforcingsGroundediceMeltingRateEnum)
+	fmb_input       = GetInput(element, BasalforcingsFloatingiceMeltingRateEnum)
+   smb_input       = GetInput(element, SmbMassBalanceEnum)
+	olevelset_input = GetInput(element, MaskOceanLevelsetEnum)
+	dt            = FindParam(element, TimesteppingTimeStepEnum)
+	stabilization = FindParam(element, MasstransportStabilizationEnum)
+
+   #How much is actually grounded?
+	phi=GetGroundedPortion(element, xyz_list)
+
+	#Start integrating
+	gauss = GaussTria(3)
+	for ig in 1:gauss.numgauss
+
+		Jdet = JacobianDeterminant(xyz_list, gauss)
+		NodalFunctions(element, basis, gauss, ig, P1Enum)
+
+		smb = GetInputValue(smb_input, gauss, ig)
+      H   = GetInputValue(H_input, gauss, ig)
+
+      #Only apply melt on fully floating cells
+      if(phi<0.00000001)
+         mb = GetInputValue(fmb_input, gauss, ig)
+      else
+         mb = GetInputValue(gmb_input, gauss, ig)
+      end
+
+		for i in 1:numnodes
+         pe.values[i] += gauss.weights[ig]*Jdet*(H + dt*(smb - mb))*basis[i]
+		end
+	end
+
+	return pe
+end #}}}
+function GetSolutionFromInputs(analysis::MasstransportAnalysis,ug::IssmVector,element::Tria) #{{{
+
+	#Get dofs for this finite element
+	doflist = GetDofList(element,GsetEnum)
+	@assert length(doflist)==3
+
+	#Fetch inputs
+	thickness_input = GetInput(element, ThicknessEnum)
+
+	#Loop over each node and enter solution in ug
+	count = 0
+	gauss=GaussTria(P1Enum)
+	for i in 1:gauss.numgauss
+		thickness = GetInputValue(thickness_input, gauss, i)
+
+		count += 1
+		ug.vector[doflist[count]] = thickness
+	end
+
+	#Make sure we reached all the values
+	@assert count==length(doflist)
+
+end#}}}
+function InputUpdateFromSolution(analysis::MasstransportAnalysis,ug::Vector{Float64},element::Tria) #{{{
+
+	#Get dofs for this finite element
+	doflist = GetDofList(element,GsetEnum)
+
+	#Get solution vector for this element
+	numdof   = 3
+	values = Vector{Float64}(undef,numdof)
+	for i in 1:numdof values[i]=ug[doflist[i]] end
+
+	#Get some parameters
+	rho_water = FindParam(element, MaterialsRhoSeawaterEnum)
+	rho_ice   = FindParam(element, MaterialsRhoIceEnum)
+	H_min     = FindParam(element, MasstransportMinThicknessEnum)
+
+	#Now split solution vector into x and y components
+	numnodes = 3
+	thickness  = Vector{Float64}(undef,numnodes)
+	for i in 1:numnodes 
+		thickness[i]=values[i] 
+		@assert isfinite(thickness[i])
+
+		#Enforce minimum thickness
+		if(thickness[i]<H_min)
+			thickness[i] = H_min
+		end
+	end
+	AddInput(element, ThicknessEnum,  thickness,  P1Enum)
+
+	#Update bed and surface accordingly
+	newthickness = Vector{Float64}(undef,3)
+	oldthickness = Vector{Float64}(undef,3)
+	oldbase      = Vector{Float64}(undef,3)
+	oldsurface   = Vector{Float64}(undef,3)
+	phi          = Vector{Float64}(undef,3)
+	bed          = Vector{Float64}(undef,3)
+	GetInputListOnVertices!(element, newthickness, ThicknessEnum)
+   GetInputListOnVertices!(element, oldthickness, ThicknessOldEnum)
+   GetInputListOnVertices!(element, oldbase, BaseOldEnum)
+   GetInputListOnVertices!(element, oldsurface, SurfaceOldEnum)
+   GetInputListOnVertices!(element, phi, MaskOceanLevelsetEnum)
+	GetInputListOnVertices!(element, bed, BedEnum)
+   sealevel = zeros(3)
+	newsurface = Vector{Float64}(undef,3)
+	newbase    = Vector{Float64}(undef,3)
+
+   for i in 1:3
+      if(phi[i]>0.)
+         #this is grounded ice: just add thickness to base.
+         newsurface[i] = bed[i]+newthickness[i] #surface = bed + newthickness
+         newbase[i]    = bed[i]                 #new base at new bed
+      else
+         #this is an ice shelf: hydrostatic equilibrium
+         newsurface[i] = newthickness[i]*(1-rho_ice/rho_water) + sealevel[i]
+         newbase[i]    = newthickness[i]*(-rho_ice/rho_water)  + sealevel[i]
+      end
+   end
+
+	AddInput(element, SurfaceEnum, newsurface, P1Enum)
+	AddInput(element, BaseEnum,    newbase,    P1Enum)
+end#}}}
+function UpdateConstraints(analysis::MasstransportAnalysis, femmodel::FemModel) #{{{
+	SetActiveNodesLSMx(femmodel)
+end#}}}
